//
// File:         Comparison.h
// Description:  
// Created:      Jan 26, 2001, 11:00
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//==================================================================
#ifndef COMPARISON_H
//===================================================================
#define COMPARISON_H
#ifndef NO_DEBUG_VIS
 #include <iostream.h>
#endif
#include "jargon.h"
#include "BLDebugFlags.h"
//================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_COMPARISON
 #define DEBUG_NAMESPACE "Comparison"
#endif
#include "debugMacros.h"
//=================================================
enum Comparison 
 {
  Less = -1,
  Equal = 0,
  Greater = 1,
  Incomparable = 2 
 };

inline Comparison inverse(const Comparison& cmp)
{
 CALL("(global) inverse(const Comparison& cmp)");
 switch (cmp)
  {
   case Less: return Greater;
   case Equal: return Equal;
   case Greater: return Less;
   case Incomparable: return Incomparable;  
   #ifdef DEBUG_NAMESPACE
    default: ICP("ICP0"); return Incomparable; 
   #elif defined _SUPPRESS_WARNINGS_
    default: return Incomparable; 
   #endif              
  };
 #ifdef DEBUG_NAMESPACE
  ICP("ICP1"); 
  return Incomparable; 
 #elif defined _SUPPRESS_WARNINGS_
  return Incomparable; 
 #endif    
}; 

inline ostream& operator<<(ostream& str,const Comparison& cmp) 
{
 switch (cmp)
  {
   case Less: return str << "Less";
   case Equal: return str << "Equal"; 
   case Greater: return str << "Greater";
   case Incomparable: return str << "Incomparable";     
  };
 return str << "UNKNOWN";    
};


//=================================================
#undef DEBUG_NAMESPACE 
//=================================================
#endif 
