//
// File:         PrologTerm.h
// Description:  Abstract class for printed prolog terms.
// Created:      Oct 24, 1999, 14:45
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//=======================================================================
#ifndef PROLOG_TERM_H
//=======================================================================
#define PROLOG_TERM_H
#include <iostream.h>

#if (COMPILER != COMPILER_MS_VISUAL_C_PLUS_PLUS)
 #include <strstream.h>
#else
 #include <strstrea.h>
#endif

#include <string.h> 
#include "jargon.h"
#include "OutPort.h"
//=======================================================================

class PrologTerm
{
 public:
  virtual ~PrologTerm() {}; 
  virtual OutPort& outputAsPrologTerm(OutPort& port) const = 0;
  friend OutPort& operator<<(OutPort& port,const PrologTerm& t);
};

inline OutPort& operator<<(OutPort& port,const PrologTerm& t)
{
 return t.outputAsPrologTerm(port);
}; // OutPort& operator<<(OutPort& port,const PrologTerm& t)


//=======================================================================
#endif
