//
// File:         TmpString.h
// Description:  
// Created:      Oct 24, 1999, 16:30
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//======================================================================
#ifndef TMP_STRING_H
//=======================================================================
#define TMP_STRING_H
#if (COMPILER != COMPILER_MS_VISUAL_C_PLUS_PLUS)
 #include <strstream.h>
#else
 #include <strstrea.h>
#endif
#include <string.h>
#include "jargon.h"
//=======================================================================
class TmpString
{
 public:
  TmpString() : strn(new char[1]) { strn[0] = '\0';};
  TmpString(char c)
  {
   strn = new char[2];
   strn[0] = c;
   strn[1] = '\0'; 
  }; 
  TmpString(const char* s)
  {
   strn = new char[strlen(s) + 1];
   strcpy(strn,s);
  };
  TmpString(int n) 
  {
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  TmpString(unsigned n) 
  {
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  TmpString(long n) 
  {
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str()); 
  };
  TmpString(unsigned long n) 
  {
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  TmpString(float n) 
  {
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  TmpString(double n) 
  {
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  TmpString(bool n) 
  {
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  TmpString(const char* s1,const char* s2)
  {
   strn = new char[strlen(s1) + strlen(s2) + 1];
   strcpy(strn,s1);
   strcpy(strn + strlen(s1),s2);
  };
  TmpString(const char* s1,const char* s2,const char* s3)
  {
   strn = new char[strlen(s1) + strlen(s2) + strlen(s3) + 1];
   strcpy(strn,s1);
   strcpy(strn + strlen(s1),s2);
   strcpy(strn + strlen(s1) + strlen(s2),s3);
  };
  TmpString(const TmpString& s) 
  {
   strn = new char[strlen(s.strn) + 1];
   strcpy(strn,s.strn);
  };
  TmpString& operator=(const TmpString& s)
  {
   delete [] strn;
   strn = new char[strlen(s.strn) + 1];
   strcpy(strn,s.strn);
   return *this;
  }; 
  ~TmpString() { delete [] strn; };

  void init(char c) 
  { 
   delete [] strn;  
   strn = new char[2];
   strn[0] = c;
   strn[1] = '\0'; 
  };
  void init(const char* s)
  {
   delete [] strn;  
   strn = new char[strlen(s) + 1];
   strcpy(strn,s);
  };
  
  void init(int n) 
  {
   delete [] strn;  
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  void init(unsigned n) 
  {
   delete [] strn;  
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  void init(long n) 
  {
   delete [] strn;  
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str()); 
  };
  void init(unsigned long n) 
  {
   delete [] strn;  
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  void init(float n) 
  {
   delete [] strn;  
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  void init(double n) 
  {
   delete [] strn;  
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  void init(bool n) 
  {
   delete [] strn;  
   ostrstream strstr;
   strstr << n << '\0';
   strn = new char[strlen(strstr.str()) + 1];
   strcpy(strn,strstr.str());
  };
  void init(const char* s1,const char* s2)
  {
   delete [] strn;  
   strn = new char[strlen(s1) + strlen(s2) + 1];
   strcpy(strn,s1);
   strcpy(strn + strlen(s1),s2);
  };
  void init(const char* s1,const char* s2,const char* s3)
  {
   delete [] strn;  
   strn = new char[strlen(s1) + strlen(s2) + strlen(s3) + 1];
   strcpy(strn,s1);
   strcpy(strn + strlen(s1),s2);
   strcpy(strn + strlen(s1) + strlen(s2),s3);
  };
  void init(const TmpString& s) 
  {
   delete [] strn;  
   strn = new char[strlen(s.strn) + 1];
   strcpy(strn,s.strn);
  };
  void destroy() { delete [] strn; };
  const char* str() const { return strn; };
  char* copy() const 
  {
   char* res = new char[strlen(strn)+1]; strcpy(res,strn); return res;
  };
 private:
  char* strn;
};
//========================================================================
#endif


