//
// File:         HellDebugFlags.h
// Description:  Debugging flags for Hell
// Created:      Feb 12, 2000, 16:10
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//=================================================================== 
#include "BLDebugFlags.h"
//=================================================================== 

#ifdef NO_DEBUG
 #undef NO_DEBUG_VIS
 #define NO_DEBUG_VIS
#endif 

//#define DEBUG_AUTO_FUNCTOR_PRECEDENCE
//#define DEBUG_CLAUSE_BACKGROUND
//#define DEBUG_BACK_DEMODULATION
//#define DEBUG_BACK_PARA_CANDIDATES
//#define DEBUG_BACKWARD_SUBSUMPTION
//#define DEBUG_BACKWARD_SUPERPOSITION
//#define DEBUG_BINARY_RESOLUTION
//#define DEBUG_B_MATCHING
//#define DEBUG_BS_INDEX
//#define DEBUG_BS_MACHINE
//#define DEBUG_CLAUSE
//#define DEBUG_CLAUSE_INDEX
//#define DEBUG_CLAUSE_NUM_INDEX
//#define DEBUG_CLAUSE_SET
//#define DEBUG_COMPONENT_NAME
//#define DEBUG_DTREE
//#define DEBUG_EQ_FACTORING
//#define DEBUG_FLATTERM
//#define DEBUG_FORWARD_SUBSUMPTION
//#define DEBUG_FORWARD_SUPERPOSITION
//#define DEBUG_FORWARD_DEMODULATION
//#define DEBUG_FS_CODE
//#define DEBUG_FS_COMMAND
//#define DEBUG_FT_UNIFICATION
//#define DEBUG_HEADER_WEIGHTING
//#define DEBUG_HYPERRESOLUTION
//#define DEBUG_HYPER_RULE
//#define DEBUG_INFERENCE_TREE
//#define DEBUG_IU_COMMAND
//#define DEBUG_KB_COMMAND
//#define DEBUG_KB_CONSTRAINT
//#define DEBUG_KEPT
//#define DEBUG_LITERAL_LIST
//#define DEBUG_LOGGING
//#define DEBUG_OPEN_NEW_CLAUSE
//#define DEBUG_OLD_BACKWARD_SUBSUMPTION
//#define DEBUG_OLD_BS_INDEX
//#define DEBUG_OLD_BS_MACHINE
//#define DEBUG_OLD_FS_CODE
//#define DEBUG_OR_INDEX
//#define DEBUG_OR_PREMISE
//#define DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
//#define DEBUG_PATH_INDEX_TREE
//#define DEBUG_PREFIX
//#define DEBUG_PREMISE_FACTORING
//#define DEBUG_NEW_CLAUSE
//#define DEBUG_SHARED_KB_CONSTR
//#define DEBUG_SHARING
//#define DEBUG_SIGNATURE 
//#define DEBUG_SIMPLE_SUBSTITUTION
//#define DEBUG_SUBSUMPTION_CHECK
//#define DEBUG_TERM
//#define DEBUG_TPTP_PARSER
//#define DEBUG_UNIFICATION 
//#define DEBUG_UNIF_KB_CONSTR
//#define DEBUG_UNIT_CONFLICT
//#define DEBUG_VARIABLES
//#define DEBUG_WEIGHT_FORMULA

#ifdef NO_DEBUG
 #undef DEBUG_AUTO_FUNCTOR_PRECEDENCE
 #undef DEBUG_CLAUSE_BACKGROUND
 #undef DEBUG_BACK_DEMODULATION
 #undef DEBUG_BACK_PARA_CANDIDATES
 #undef DEBUG_BACKWARD_SUBSUMPTION
 #undef DEBUG_BACKWARD_SUPERPOSITION
 #undef DEBUG_BINARY_RESOLUTION
 #undef DEBUG_B_MATCHING
 #undef DEBUG_BS_INDEX
 #undef DEBUG_BS_MACHINE
 #undef DEBUG_CLAUSE
 #undef DEBUG_CLAUSE_INDEX
 #undef DEBUG_CLAUSE_NUM_INDEX
 #undef DEBUG_CLAUSE_SET 
 #undef DEBUG_COMPONENT_NAME
 #undef DEBUG_DTREE
 #undef DEBUG_EQ_FACTORING
 #undef DEBUG_FLATTERM
 #undef DEBUG_FORWARD_SUBSUMPTION
 #undef DEBUG_FORWARD_SUPERPOSITION
 #undef DEBUG_FORWARD_DEMODULATION
 #undef DEBUG_FS_CODE
 #undef DEBUG_FS_COMMAND
 #undef DEBUG_FT_UNIFICATION
 #undef DEBUG_HEADER_WEIGHTING
 #undef DEBUG_HYPERRESOLUTION
 #undef DEBUG_HYPER_RULE
 #undef DEBUG_INFERENCE_TREE
 #undef DEBUG_IU_COMMAND
 #undef DEBUG_KB_COMMAND
 #undef DEBUG_KB_CONSTRAINT
 #undef DEBUG_KEPT
 #undef DEBUG_LITERAL_LIST
 #undef DEBUG_LOGGING
 #undef DEBUG_OPEN_NEW_CLAUSE
 #undef DEBUG_OR_INDEX
 #undef DEBUG_OR_PREMISE
 #undef DEBUG_OLD_BACKWARD_SUBSUMPTION
 #undef DEBUG_OLD_BS_INDEX
 #undef DEBUG_OLD_BS_MACHINE
 #undef DEBUG_OLD_FS_CODE
 #undef DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
 #undef DEBUG_PATH_INDEX_TREE
 #undef DEBUG_PREFIX 
 #undef DEBUG_PREMISE_FACTORING
 #undef DEBUG_NEW_CLAUSE
 #undef DEBUG_SHARED_KB_CONSTR
 #undef DEBUG_SHARING
 #undef DEBUG_SIGNATURE 
 #undef DEBUG_SIMPLE_SUBSTITUTION
 #undef DEBUG_SUBSUMPTION_CHECK
 #undef DEBUG_TERM
 #undef DEBUG_TPTP_PARSER
 #undef DEBUG_UNIFICATION
 #undef DEBUG_UNIF_KB_CONSTR
 #undef DEBUG_UNIT_CONFLICT
 #undef DEBUG_VARIABLES 
 #undef DEBUG_WEIGHT_FORMULA
#else
 #ifdef DEBUG_ALL
  #define DEBUG_AUTO_FUNCTOR_PRECEDENCE
  #define DEBUG_CLAUSE_BACKGROUND
  #define DEBUG_BACK_DEMODULATION
  #define DEBUG_BACK_PARA_CANDIDATES
  #define DEBUG_BACKWARD_SUBSUMPTION
  #define DEBUG_BACKWARD_SUPERPOSITION
  #define DEBUG_BINARY_RESOLUTION
  #define DEBUG_B_MATCHING
  #define DEBUG_BS_INDEX
  #define DEBUG_BS_MACHINE
  #define DEBUG_CLAUSE
  #define DEBUG_CLAUSE_INDEX
  #define DEBUG_CLAUSE_NUM_INDEX
  #define DEBUG_CLAUSE_SET
  #define DEBUG_COMPONENT_NAME
  #define DEBUG_DTREE
  #define DEBUG_EQ_FACTORING
  #define DEBUG_FLATTERM
  #define DEBUG_FORWARD_SUBSUMPTION
  #define DEBUG_FORWARD_SUPERPOSITION
  #define DEBUG_FORWARD_DEMODULATION
  #define DEBUG_FS_CODE
  #define DEBUG_FS_COMMAND
  #define DEBUG_FT_UNIFICATION
  #define DEBUG_HEADER_WEIGHTING 
  #define DEBUG_HYPERRESOLUTION
  #define DEBUG_HYPER_RULE
  #define DEBUG_INFERENCE_TREE
  #define DEBUG_IU_COMMAND
  #define DEBUG_KB_COMMAND
  #define DEBUG_KB_CONSTRAINT
  #define DEBUG_KEPT
  #define DEBUG_LITERAL_LIST
  #define DEBUG_LOGGING
  #define DEBUG_OPEN_NEW_CLAUSE
  #define DEBUG_OR_INDEX
  #define DEBUG_OR_PREMISE
  #define DEBUG_OLD_BACKWARD_SUBSUMPTION
  #define DEBUG_OLD_BS_INDEX
  #define DEBUG_OLD_BS_MACHINE
  #define DEBUG_OLD_FS_CODE
  #define DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
  #define DEBUG_PATH_INDEX_TREE
  #define DEBUG_PREFIX
  #define DEBUG_PREMISE_FACTORING
  #define DEBUG_NEW_CLAUSE
  #define DEBUG_SHARED_KB_CONSTR
  #define DEBUG_SHARING
  #define DEBUG_SIGNATURE
  #define DEBUG_SIMPLE_SUBSTITUTION
  #define DEBUG_SUBSUMPTION_CHECK
  #define DEBUG_TERM
  #define DEBUG_TPTP_PARSER
  #define DEBUG_UNIFICATION  
  #define DEBUG_UNIF_KB_CONSTR
  #define DEBUG_UNIT_CONFLICT
  #define DEBUG_VARIABLES
  #define DEBUG_WEIGHT_FORMULA
 #endif
#endif


//==========================================================================

