#include "clause_index.h"
//==================================================
#undef DEBUG_NAMESPACE  
#ifdef DEBUG_CLAUSE_INDEX
 #define DEBUG_NAMESPACE "LITERAL_INDEX"
#endif
#include "debugMacros.h"
//=================================================

void LITERAL_INDEX::Destroy()
 {
  CALL("Destroy()");
  TERM prop_lit; 
  for (unsigned long prop_var = 0; prop_var < HellConst::MaxNumOfFunctors; prop_var++)
   {
    prop_lit.MakeComplex((TERM::Arity)0,(TERM::Functor)prop_var,TERM::PositivePolarity);
    *(Share(prop_lit)->InfoField()) = (void*)0;
    prop_lit.Inversepolarity();
    *(Share(prop_lit)->InfoField()) = (void*)0; 
   }; 
  for (unsigned long i = 0; i < HellConst::MaxNumOfFunctors; i++)
   {

    DTREE::Destroy(positive[i],DestroyLeafContent);
    positive[i] = (DTREE_NODE*)0;
   };

  for (unsigned long j = 0; j < HellConst::MaxNumOfFunctors; j++)
   {
    DTREE::Destroy(negative[j],DestroyLeafContent);
    negative[j] = (DTREE_NODE*)0;
   };  
 }; //void LITERAL_INDEX::Destroy()  

void LITERAL_INDEX::DestroyLeafContent(DTREE_NODE* leaf)
 {  
  if (leaf->Term()->arity()) 
   leaf->Term()->DeleteLit();
 }; // void LITERAL_INDEX::DestroyLeafContent(DTREE_NODE* leaf)


//*******************************************************************************
