#include "prefix.h"
//================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_PREFIX
 #define DEBUG_NAMESPACE "PREFIX"
#endif
#include "debugMacros.h"
//================================================= 

#ifndef NO_DEBUG_VIS
 ostream& PREFIX::outputWord(ostream& str,const PREFIX_SYM* word)
 {
  SIMPLE_ITER w_iter;
  w_iter.Reset((PREFIX_SYM*)word);
  while (!(w_iter.Empty()))
   {
    str << '<' << (unsigned long)w_iter.CurrPos() << "> ";
    w_iter.CurrPos()->output(str) << '\n';
    w_iter.SkipSym();
   };     
  return str;
 }; // ostream& PREFIX::outputWord(ostream& str,const PREFIX_SYM* word)  

 ostream& PREFIX::outputWordWithSubst(ostream& str,const PREFIX_SYM* word)
 {
  ITER w_iter;
  w_iter.Reset((PREFIX_SYM*)word);
  while (!(w_iter.Empty()))
   {
    if (w_iter.CurrVar())
     {
      w_iter.CurrVar()->output(str);
     }
    else w_iter.CurrSubterm()->output(str);
    str << '\n';
    w_iter.SkipSym();
   };
  return str;
 }; // ostream& PREFIX::outputWordWithSubst(ostream& str,const PREFIX_SYM* word)
  
 ostream& PREFIX::outputTerm(ostream& str,const PREFIX_SYM* word)
 {
  if (word->Head().isVariable()) return word->Head().output(str);
  SIMPLE_ITER w_iter;
  BracketCounter<HellConst::MaxTmpTermDepth> brack_counter;
  w_iter.Reset((PREFIX_SYM*)word);
  while (!(w_iter.Empty()))
   {
    w_iter.CurrPos()->Head().output(str);
    if ((w_iter.CurrPos()->Head().IsFunctor()) 
        && (w_iter.CurrPos()->Head().Func().arity()))
     {
      brack_counter.Open(w_iter.CurrPos()->Head().Func().arity());
      str << '(';
      w_iter.SkipSym();
     }
    else
     {
      unsigned closed = brack_counter.Close();
      while (closed) { str << ')';  closed--; };
      w_iter.SkipSym();
      if (!(w_iter.Empty())) str << ',';
     };
   };       
  return str;
 }; // ostream& PREFIX::outputTerm(ostream& str,const PREFIX_SYM* word)
#endif


//================================================= 
