//
// File:         term.cpp
// Description:  Representation of stored terms.
// Created:      Oct 15, 1999, 15:00
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//====================================================
#include "term.h"
//====================================================
#ifdef DEBUG_ALLOC_OBJ_TYPE
 ClassDesc TERM::OccList::_classDesc("TERM::OccList",
                                     TERM::OccList::minSize(),
                                     TERM::OccList::maxSize());
 
 ClassDesc TERM::OccList::_headerClassDesc("TERM::OccList(header)",
                                           TERM::OccList::headerMinSize(),
                                           TERM::OccList::headerMaxSize());

 ClassDesc TERM::OccList::Node::_classDesc("TERM::OccList::Node",
                                           TERM::OccList::Node::minSize(),
                                           TERM::OccList::Node::maxSize());
#endif
TERM TERM::_sharedConst[2*HellConst::MaxNumOfFunctors];
Signature* TERM::_signature = (Signature*)0;

TERM TERM::_dummyPositiveHeader0;
TERM TERM::_dummyPositiveHeader1;
TERM TERM::_positiveOrdEqHeader;
TERM TERM::_negativeOrdEqHeader;
TERM TERM::_positiveUnordEqHeader;
TERM TERM::_negativeUnordEqHeader;

//================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_TERM
 #define DEBUG_NAMESPACE "TERM"
#endif
#include "debugMacros.h"
//=================================================

ulong TERM::size() const
{
 CALL("size() const");
 ulong res = 1;
 if (!isVariable())
  {
   Iterator iter(this);
   while (iter.Next()) res++;
  };
 return res;
};

ulong TERM::depth() const
{
 CALL("depth() const");
 ulong res = 0;
 IteratorWithDepth iter;
 iter.Reset((TERM*)this,0);
 while (iter.Next()) 
  if (iter.Depth() > res) res = iter.Depth();
 return res;
};
//================================================
#undef DEBUG_NAMESPACE   
//====================================================
