// *************************************************************
//
//  Class Array<C> for implementing dynamic arrays
//  13/04/2001 Manchester
//  09/05/2001 Manchester, bug fixed 
//
// *************************************************************


#ifndef __array__
#  define __array__


#include "debug.h"
#include "assert.h"


// ******************* Class Array, definitions *****************


template <class C>
class Array
{
 public:

  Array (int sz) :
    #ifdef debug_array
      _size ( sz ),
    #endif
    _array ( new C [sz] )
    {}

  ~Array ()
    { delete [] _array; }

  C& operator [] ( int index )
  { 
    ASSERT( debug_array, index >= 0 && index < _size );
    return _array[index]; 
  }

 private:
  #ifdef debug_array
    int _size;
  #endif
  C* _array;
};  // class Array


#endif


