// *************************************************************
//
//  Class Pair<C,D> for implementing pairs
//
//  14/04/2000 Breckenridge
//  02/06/2000 Manchester, == added
//
// *************************************************************

#ifndef __pair__
#  define __pair__


// #include "memory.h"
#include "assert.h"


// *******************Class Pair*******************************


template <class C,class D>
class Pair
{
 public:

  // constructors
  Pair ( C left, D right );
  Pair ();

  // structure quering
  C left ();
  D right ();

  // change left/right elements
  void left ( C );
  void right ( D );

  // equality
  bool operator == ( Pair& rhs );

  // memory management
//  void* operator new ( size_t );
//  void operator delete ( void* obj );

 protected:  // structure

  C _left;
  D _right;
  // for debugging 
  static const char* name ();
};  // class Pair


// ******************* Class Pair, definitions ****************************


template <class C,class D>
inline
const char* Pair<C,D>::name ()
{
  return "Pair";
}


//template <class C,class D>
//inline
//void* Pair<C,D>::operator new (size_t)
//{
//  return Memory::alloc ( sizeof(Pair<C,D>), name () );
//}
//
//
//template <class C,class D>
//inline
//void Pair<C,D>::operator delete (void* obj)
//{
//  Memory::dealloc ( obj, sizeof (Pair<C,D>), name () );
//}


template <class C,class D>
inline
Pair<C,D>::Pair ()
{
}


template <class C,class D>
inline
Pair<C,D>::Pair (C lft, D rht)
  :
  _left ( lft ),
  _right ( rht )
{
}


template <class C,class D>
inline
C Pair<C,D>::left ()
{
  return _left;
}


template <class C,class D>
inline
D Pair<C,D>::right ()
{
  return _right;
}


template <class C,class D>
inline
void Pair<C,D>::left ( C lft )
{
  _left = lft;
}


template <class C,class D>
inline
void Pair<C,D>::right ( D rht )
{
  _right = rht;
}


template <class C,class D>
inline
bool Pair<C,D>::operator == ( Pair<C,D>& rhs ) 
{
  return left() == rhs.left() &&
         right() == rhs.right();
} // Pair::operator ==


#endif


