//
//  file property.h (syntactic properties of problems)
//  06/06/2001 Manchester
//


#ifndef __property__
#define __property__


class Problem;
class ostream;


class Property {
 public:

  enum Input {
    FO,
    CLAUSAL
  };

  enum Category {
    NEQ,
    HEQ,
    PEQ,
    UEQ,
    EUEQ, // essentially UEQ
    HNE,
    NNE,
    EPR,
    PROP
  };

  // constructor
  explicit Property (Problem&);

  // output
  void toString (char* string);

  bool hasEquality () const; 
 private:
  Category category () const { return _category; };
  void category (Category c) { _category = c; };

  // structure
  Category _category;
  bool _equalityInGoal;
  int _goalWeight;
}; // class Property


ostream& operator << ( ostream&, Property& );


#endif // __property__
