//
//  file strategy.cpp (strategies)
//  07/06/2001 Manchester
//


#include <string.h>

#include "strategy.h"
#include "property.h"
#include "prepro.h"
#include "options.h"
#include "int.h"


Strategy::Strategy (Property& prop)
  :
  _property (prop)
{
} // Strategy::Strategy


void Strategy::execute (Prepro& prepro, ostream& opts, ostream& problem, 
                        int timeLimit,int memLimit,char* tabFile, ostream& tab )
{
  char pro [100]; // 100 is enough
  _property.toString (pro);

  Strat strat = UNDEFINED;  
  Pre pre = NONE;  

  if ( ! strcmp (pro,"h0010060002_55n") ) {  
    strat = EPR;
  }
  if ( ! strcmp (pro,"h0012051200_3n") ) {              
    strat = dis_2;
  }
  if ( ! strcmp (pro,"N0001150105_7y") ||  
       ! strcmp (pro,"h0100031100_12n") ) {                         
    strat = dis_5;    
  }
  else if ( ! strcmp (pro,"H0010031300_9y") || 
            ! strcmp (pro,"N0120051400_5n") ||  
            ! strcmp (pro,"N068228Ua73_9n") ) {
    strat = dis_1002;
  }
  else if ( ! strcmp (pro,"N0210091000_15y") ) { 
    strat = EPR;
  }
  else if ( ! strcmp (pro,"n0040031300_7n") ) { 
    strat = dis_1003;
  }
  else if ( ! strcmp (pro,"N0001190106_11y") ) { 
    pre = E;
    strat = EPR;
  }
  else if ( ! strcmp (pro,"N05740SXO70_5n") ||  
            ! strcmp (pro,"N05230PTK50_13n") ) { 
    pre = A;               
    strat = dis_n3;
  }
  else if ( ! strcmp (pro,"n0222066000_8n") ||  
            ! strcmp (pro,"P0000071100_28y") ) { 
    strat = dis_n4;
  }
  else if ( ! strcmp (pro,"N06511OUZ62_8n") || 
            ! strcmp (pro,"N0KK007z800_73y") ) {  
    strat = lrs_1;  
  }
  else if ( ! strcmp (pro,"N0001190105_11y") ) {  
    strat = lrs_1_kinky;
  }
  else if ( ! strcmp (pro,"N0001170105_3y") ) {  
    strat = HEU008;
  }
  else if ( ! strcmp (pro,"H0200021200_10n") || 
            ! strcmp (pro,"H0200021200_11n") ) { 
    pre = CD,
    strat = lrs_1_lcn;
  }
  else if ( ! strcmp (pro,"H0010090100_3n") || 
            ! strcmp (pro,"H0200011400_6n") || 
            ! strcmp (pro,"P0000051300_11y") || 
            ! strcmp (pro,"N0KK005z900_105y") ) { 
    strat = lrs_2;
  }
  else if ( ! strcmp (pro,"N05230NTK50_11y") ) { 
    pre = A;
    strat = lrs_2_kinky;
  }
  else if ( ! strcmp (pro,"N0001170005_3y") ) { 
    strat = lrs_4; 
  }
  else if ( ! strcmp (pro,"n0112052200_22n") || 
            ! strcmp (pro,"n0112062200_31n") || 
            ! strcmp (pro,"n0112082200_38n") || 
            ! strcmp (pro,"n01120L2200_53n") || 
            ! strcmp (pro,"h0020058200_86n") || 
            ! strcmp (pro,"h0100011100_7n") || 
            ! strcmp (pro,"h0100031100_16n") ) { 
    strat = lrs_4_lcn;
  }
  else if ( ! strcmp (pro,"N05230NTK50_8y") ) { 
    pre = A;
    strat = lrs_4_lcn;
  }
  else if ( ! strcmp (pro,"N05740TXO70_4n") || 
            ! strcmp (pro,"N05740TXO70_6y") || 
            ! strcmp (pro,"N05740TXO70_7y") || 
            ! strcmp (pro,"N05740TXO70_8n") || 
            ! strcmp (pro,"N052209PK50_20y") ||
            ! strcmp (pro,"N052209PK50_26y") || 
            ! strcmp (pro,"N052209PL50_6y") || 
            ! strcmp (pro,"N05220LPL50_16y") || 
            ! strcmp (pro,"N05230NTK50_5y") || 
            ! strcmp (pro,"N05230OTK50_14y") || 
            ! strcmp (pro,"N05230OTK50_5n") || 
            ! strcmp (pro,"N05230OTK50_7y") || 
            ! strcmp (pro,"N05230OTK50_8y") ||
            ! strcmp (pro,"N05230QTK50_12n") || 
            ! strcmp (pro,"N05220LPL50_11y") || 
            ! strcmp (pro,"N05230QTK50_13n") ) { 
    pre = C;
    strat = lrs_4_lcn;
  }
  else if ( ! strcmp (pro,"H0200021200_12n") ) { 
    pre = CD; 
    strat = lrs_4_lcn;
  }
  else if (! strcmp (pro,"h0100040100_16n") ) {
    strat = lrs_4_kinky;
  }
  else if ( ! strcmp (pro,"N05230OTK50_6n") ) { 
    pre = E;
    strat = lrs_5;
  }
  else if ( ! strcmp (pro,"N05740VXO70_11n") ) { 
    pre = A;
    strat = lrs_5_kinky; 
  }
  else if ( ! strcmp (pro,"h0100031100_15n") ) { 
    strat = HEU021;
  }
  else if ( ! strcmp (pro,"n0112032200_6n") ) { 
    strat = lrs_7_lcn;
  }
  else if ( ! strcmp (pro,"H0100050100_16n") ) { 
    strat = dis_4;
  }
  else if ( ! strcmp (pro,"H0200011400_7n") ) { 
    pre = E;
    strat = lrs_1002;
  }
  else if ( ! strcmp (pro,"h0060085800_0n") ) { 
    strat = lrs_1003;
  }
  else if ( ! strcmp (pro,"H0200031200_12n") ) { 
    pre = CD;
    strat = lrs_1003;
  }
  else if ( ! strcmp (pro,"H0200021400_9n") || 
       ! strcmp (pro,"N0010041300_20n") ) {  
    pre = E;
    strat = lrs_1003;
  }
  else if ( ! strcmp (pro,"N00100L1100_3n") ) { 
    strat = lrs_1004;
  }
  else if ( ! strcmp (pro,"N00100R1100_3n") ) { 
    pre = C;
    strat = lrs_1004;
  }
  else if ( ! strcmp (pro,"N05740VXO70_16n") ) { 
    pre = E;
    strat = lrs_1004;
  }
  else if ( ! strcmp (pro,"n0120042200_18n") || 
            ! strcmp (pro,"n0120042200_15n") ) {  
    strat = lrs_1005;
  }
  else if ( ! strcmp (pro,"n0112042200_12n") ) { 
    strat = lrs_1005;
  }
  else if ( ! strcmp (pro,"H0200021400_11n") ) { 
    strat = lrs_1007; 
  }
  else if ( ! strcmp (pro,"N0KK104zP00_200y") ) { 
    strat = lrs_1007;
  }
  else if ( ! strcmp (pro,"N0KK007z800_76y") ||  
            ! strcmp (pro,"N0230077L01_24y") ||  
            ! strcmp (pro,"N0KK005z800_94y") ) { 
    strat = lrs_1008;
  }
  else if ( ! strcmp (pro,"N065118UZ62_3y") ) {   
    pre = C;
    strat = HEU029;
  }
  else if ( ! strcmp (pro,"N07822N]z73_4y") || 
            ! strcmp (pro,"H0010041300_13y") ) { 
    pre = E;
    strat = lrs_n2;
  }
  else if ( ! strcmp (pro,"H01000d1300_193y") ||  
            ! strcmp (pro,"N05740VXO70_9y") ) { 
    strat = lrs_n2_kinky;
  }
  else if ( ! strcmp (pro,"N05230OTK50_6y") || 
            ! strcmp (pro,"N05230MTK50_4y") || 
            ! strcmp (pro,"N05740TXO70_3n") ||  
            ! strcmp (pro,"N05740SXO70_4y") ) { 
    pre = A;
    strat = lrs_n2_kinky;
  }
  else if ( ! strcmp (pro,"h0200031100_21n") ) {  
    strat = lrs_n4;
  }
  else if ( ! strcmp (pro,"n0120052200_18n") || 
            ! strcmp (pro,"n0120042200_13n") ) { 
    strat = lrs_n4_kinky;
  }
  else if ( ! strcmp (pro,"N052209RK50_26y") || 
            ! strcmp (pro,"N065119UZ62_3y") || 
            ! strcmp (pro,"N05740VXO70_19y") || 
            ! strcmp (pro,"N05740VXO70_18y") || 
            ! strcmp (pro,"N05230NTK50_12y") ) { 
    pre = A;
    strat = lrs_n4_kinky;
  }
  else if ( ! strcmp (pro,"N06511KUZ62_3y") ) { 
    pre = A;
    strat = lrs_n4_kinky_awr10;
  }
  else if ( ! strcmp (pro,"n0110056000_1284n") || 
            ! strcmp (pro,"n0110056000_716n") ) { 
    strat = EPR; 
  }
  else if ( ! strcmp (pro,"N07822N]z73_4n") ) { 
    strat = ott_n4; 
  }
  else if ( ! strcmp (pro,"H0100030100_44n") ) { 
    pre = DF;
    strat = HEU003;
  }
  else if ( ! strcmp (pro,"U0000031300_19y") ) { 
    pre = C;
    strat = unit_dis_10;
  }
  else if ( ! strcmp (pro,"U0000031100_14y") ||  
            ! strcmp (pro,"U0000060120_23y") || 
            ! strcmp (pro,"U0000031220_11y") ) { 
    strat = unit_dis_50;
  }
  else if ( ! strcmp (pro,"U0000051310_16y") ) { 
    pre = EF;
    strat = unit_lrs_3;
  }
  else if ( ! strcmp (pro,"u0001091320_127y") ) { 
    strat = unit_lrs_5;
  }
  else if ( ! strcmp (pro,"U0000041100_9y") ) { 
    pre = C;
    strat = unit_lrs_5;
  }
  else if ( ! strcmp (pro,"U0000051310_37y") ) { 
    pre = EF;
    strat = unit_lrs_5;
  }
  else if ( ! strcmp (pro,"U0000031300_21y") ) { 
    strat = unit_ott_3; 
  }
  else if ( ! strcmp (pro,"N0110042200_3y") ||  
            ! strcmp (pro,"H0110042100_3y") ) { 
    strat = HEU001;
  }
  else if ( ! strcmp (pro,"u00100O1320_142y") ||  
            ! strcmp (pro,"u0010031310_163y") ) { 
    pre = C;
    strat = HEU002;
  }
  else if ( ! strcmp (pro,"H0100030100_30n") ) { 
    pre = DE;
    strat = HEU004;
  }
  else if ( ! strcmp (pro,"P0000060300_11y") ) { 
    pre = C;
    strat = HEU005;
  }
  else if ( ! strcmp (pro,"P0000051300_13y") ) { 
    pre = C;
    strat = HEU006;
  }
  else if ( ! strcmp (pro,"n0112072200_37n") ) { 
    strat = HEU007;
  }
  else if ( ! strcmp (pro,"N0001160005_7y") ) { 
    strat = HEU009;
  }
  else if ( ! strcmp (pro,"N0001150005_11y") ) { 
    strat = HEU010;
  }
  else if ( ! strcmp (pro,"N0001170005_4n") ) { 
    strat = HEU011; 
  }
  else if ( ! strcmp (pro,"P0000080200_47y") ) { 
    strat = HEU012;
  }
  else if ( ! strcmp (pro,"P0000030200_60y") ) { 
    strat = HEU013;
  }
  else if ( ! strcmp (pro,"h0100031100_14n") ) { 
    strat = HEU014;
  }
  else if ( ! strcmp (pro,"h0100030100_12n") ) { 
    strat = lrs_4_lcn;
  }
  else if ( ! strcmp (pro,"h0100050100_24n") ) {  
    strat = HEU015;
  }
  else if ( ! strcmp (pro,"h0200031100_17n") ) {  
    strat = HEU016;
  }
  else if ( ! strcmp (pro,"H0200031200_14n") ) { 
    pre = CD;
    strat = HEU017;
  }
  else if ( ! strcmp (pro,"H0200031300_12n") ) { 
    pre = CD;   
    strat = HEU018;
  }
  else if ( ! strcmp (pro,"H0200021400_10n") ) { 
    pre = E;
    strat = HEU019;  
  }
  else if ( ! strcmp (pro,"h0100041100_16n") ) { 
    strat = HEU020;
  }
  else if ( ! strcmp (pro,"h0100041100_18n") ) { 
    strat = HEU022;
  }
  else if ( ! strcmp (pro,"h0100021100_12n") ) { 
    strat = HEU023;
  }
  else if ( ! strcmp (pro,"N0KK005zL00_84y") ) { 
    strat = HEU024;
  }
  else if ( ! strcmp (pro,"N0KK008zL00_120y") ) { 
    strat = HEU025;
  }
  else if ( ! strcmp (pro,"N05740UXO70_8n") ) { 
    pre = A;
    strat = HEU026;
  }
  else if ( ! strcmp (pro,"N05740SXO70_3n") || 
            ! strcmp (pro,"N05740SXO70_4n") ) { 
    pre = E;
    strat = HEU027;
  }
  else if ( ! strcmp (pro,"n0045021100_7n") ) { 
    strat = HEU028;
  }
  else if ( ! strcmp (pro,"N023006KM30_35y") ) { 
    strat = HEU030;
  }
  else if ( ! strcmp (pro,"n0110066000_809n") ||  
            ! strcmp (pro,"n0110066000_812n") ) { 
    strat = HEU031;
  }
  else if ( ! strcmp (pro,"P000006L300_500y") ) { 
    strat = HEU032;
  }
  else if ( ! strcmp (pro,"H0100032200_15y") ) { 
    strat = HEU033;
  }
  else if ( ! strcmp (pro,"n0120042200_12n") ) {  
    strat = slicing_01;
  }
  else if ( ! strcmp (pro,"n0112062200_30n") ) { 
    strat = slicing_02;
  }
  else if ( ! strcmp (pro,"h0100050100_20n") ) { 
    strat = slicing_03;
  }
  else if ( ! strcmp (pro,"P0000080100_28y") ||  
            ! strcmp (pro,"U0000080120_28y") ) { 
    strat = slicing_04;
  }
  else if ( ! strcmp (pro,"H0200021400_12n") ) { 
    pre = DE;   
    strat = slicing_05; 
  }
  else if ( ! strcmp (pro,"H0200021400_8n") ) { 
    pre = DE;
    strat = slicing_06;
  }
  else if ( ! strcmp (pro,"N05230OTK50_9y") ) { 
    pre = C;
    strat = slicing_07;
  }
  else if ( ! strcmp (pro,"U0000040100_9y") ) { 
    pre = CF;
    strat = slicing_08; 
  }
  else if ( ! strcmp (pro,"N05230OTK50_10y") ) { 
    pre = C;
    strat = slicing_09;
  }

  if ( strat == UNDEFINED ) { 
    switch ( pro[0] ) {
      case 'N':
        pre = A;
        strat = NEQ;
        break;

      case 'H':
        pre = AD;
        strat = HEQ;
        break;

      case 'P':
        pre = A;
        strat = PEQ;
        break;

      case 'U':
      case 'u':
        pre = AF;
        strat = UEQ;
        break;

      case 'h':
        pre = D;
        strat = HNE;
        break;

      case 'n':
        strat = NNE;
        break;
      
      case 'e':
      case 'p':
        strat = EPR;
        break;
    }
  }

  // first. preprocess the problem
  switch ( pre ) {
    case A:
      prepro.simplifyA (tab);
      break;
    
    case C:
      prepro.simplifyC (tab);
      break;
    
    case D:
      prepro.simplifyD (tab);
      break;
    
    case E:
      prepro.simplifyE (tab);
      break;
    
    case F:
      prepro.simplifyF (tab);
      break;
    
    case AD:
      prepro.simplifyA (tab);
      prepro.simplifyD (tab);
      break;
    
    case AF:
      prepro.simplifyA (tab);
      prepro.simplifyF (tab);
      break;

    case CD:
      prepro.simplifyC (tab);
      prepro.simplifyD (tab);
      break;

    case CF:
      prepro.simplifyC (tab);
      prepro.simplifyF (tab);
      break;

    case DE:
      prepro.simplifyD (tab);
      prepro.simplifyE (tab);
      break;

    case DF:
      prepro.simplifyD (tab);
      prepro.simplifyF (tab);
      break;

    case EF:
      prepro.simplifyE (tab);
      prepro.simplifyF (tab);
      break;

    case NONE:
      break;
  }
  problem << prepro;

  Options options;
  options.tabFile (tabFile);
  options.timeLimit (timeLimit);
  options.memoryLimit (memLimit*3/4);
  const int min = 55;
  int slice2 = Int::max (timeLimit/2,min);
  int slice3 = Int::max (timeLimit/3,min);
  int slice4 = Int::max (timeLimit/4,min);
  int slice5 = Int::max (timeLimit/5,min);

  switch ( strat ) {
    case NEQ: 
      options.timeLimit (slice5);
      
      // best strategy first
      options.timeLimit (2*slice5);
      options.lrs (4,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";

      options.reset ();
      options.timeLimit (slice5);
      options.lrs (-4,5);
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (slice5);
      options.lrs (1003,5);
      opts << options << "\n";

      options.reset ();
      options.timeLimit (Int::max(1,timeLimit - 4*slice5));
      options.lrs (5,5);
      opts << options << "\n";
      return;

    case NNE:
      options.timeLimit (slice5);

      options.lrs (-4,5);
      opts << options << "\n";
      
      options.reset ();
      options.lrs (1005,5);
      opts << options << "\n";
      
      options.reset ();
      options.lrs (1003,5);
      opts << options << "\n";
      
      options.reset ();
      options.lrs (1002,5);
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (timeLimit - 4*slice5);
      options.lrs (1,5);
      opts << options << "\n";
      return;

    case HEQ:
      options.timeLimit (slice3);

      options.reset ();
      options.lrs (1002,5);
      opts << options << "\n";
      
      options.reset ();
      options.lrs (-5,5);
      opts << options << "\n";
      
      options.timeLimit (timeLimit - 2*slice3);
      options.reset ();
      options.lrs (3,5);
      opts << options << "\n";
      return;

    case PEQ:
      options.timeLimit (slice5);
      
      options.lrs (1003,5);
      opts << options << "\n";
      
      options.reset ();
      options.lrs (4,5);
      opts << options << "\n";

      options.reset ();
      options.lrs (1007,5);
      opts << options << "\n";

      options.reset ();
      options.timeLimit (timeLimit - 2*slice5);
      options.lrs (-4,5);
      opts << options << "\n";
      return;

    case HNE:
      options.timeLimit (slice4);
      
      options.lrs (1003,5);
      opts << options << "\n";
      
      options.reset ();
      options.lrs (-4,5);
      opts << options << "\n";

      options.reset ();
      options.lrs (5,5);
      opts << options << "\n";

      options.reset ();
      options.timeLimit (timeLimit - 3*slice4);
      options.lrs (1,5);
      opts << options << "\n";
      return;

    case UEQ:
      options.ueq (Options::LRS,5);
      opts << options << "\n";
      return;

    case EPR:
      options.lrs (5,10);
      options.fullSplitting ();
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case dis_1:
      options.discount (1,5);
      opts << options << "\n";
      return;

    case dis_2:
      options.discount (2,5);
      opts << options << "\n";
      return;

    case dis_4:
      options.discount (4,5);
      opts << options << "\n";
      return;

    case dis_5:
      options.discount (5,5);
      opts << options << "\n";
      return;

    case dis_n3:
      options.discount (-3,5);
      opts << options << "\n";
      return;

    case dis_n4:
      options.discount (-4,5);
      opts << options << "\n";
      return;

    case dis_n5:
      options.discount (-5,5);
      opts << options << "\n";
      return;

    case dis_1002:
      options.discount (1002,5);
      opts << options << "\n";
      return;

    case dis_1004:
      options.discount (1004,5);
      opts << options << "\n";
      return;

    case dis_1003:
      options.discount (1003,5);
      opts << options << "\n";
      return;

    case lrs_1: 
      options.lrs (1,5);
      opts << options << "\n";
      return;

    case lrs_1_lcn:
      options.lrs (1,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      return;

    case lrs_1_kinky: 
      options.lrs (1,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_2: 
      options.lrs (2,5);
      opts << options << "\n";
      return;

    case lrs_2_kinky: 
      options.lrs (2,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_3: 
      options.lrs (3,5);
      opts << options << "\n";
      return;

    case lrs_4: 
      options.lrs (4,5);
      opts << options << "\n";
      return;

    case lrs_3_kinky: 
      options.lrs (3,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_4_kinky: 
      options.lrs (4,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_4_lcn:
      options.lrs (4,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      return;

    case lrs_5:
      options.lrs (5,5);
      opts << options << "\n";
      return;

    case lrs_5_lcn:
      options.lrs (5,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      return;

    case lrs_5_kinky: 
      options.lrs (5,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_7_lcn:
      options.lrs (7,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      return;

    case lrs_1002: 
      options.lrs (1002,5);
      opts << options << "\n";
      return;

    case lrs_1003: 
      options.lrs (1003,5);
      opts << options << "\n";
      return;

    case lrs_1004:
      options.lrs (1004,5);
      opts << options << "\n";
      return;

    case lrs_1005: 
      options.lrs (1005,5);
      opts << options << "\n";
      return;

    case lrs_1006: 
      options.lrs (1006,5);
      opts << options << "\n";
      return;

    case lrs_1007: 
      options.lrs (1007,5);
      opts << options << "\n";
      return;

    case lrs_1008: 
      options.lrs (1008,5);
      opts << options << "\n";
      return;

    case lrs_n2: 
      options.lrs (-2,5);
      opts << options << "\n";
      return;

    case lrs_n2_kinky: 
      options.lrs (-2,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_n4:
      options.lrs (-4,5);
      opts << options << "\n";
      return;

    case lrs_n4_kinky: 
      options.lrs (-4,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_n4_kinky_awr10: 
      options.lrs (-4,5);
      options.awr (10);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case lrs_n5: 
      options.lrs (-5,5);
      opts << options << "\n";
      return;

    case lrs_n5_kinky: 
      options.lrs (-5,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case ott_1: 
      options.otter (1,5);
      opts << options << "\n";
      return;

    case ott_n4: 
      options.otter (-4,5);
      opts << options << "\n";
      return;

    case unit_lrs_3: 
      options.ueq (Options::LRS,3);
      opts << options << "\n";
      return;

    case unit_lrs_5:
      options.ueq (Options::LRS,5);
      opts << options << "\n";
      return;

    case unit_lrs_26:
      options.ueq (Options::LRS,26);
      opts << options << "\n";
      return;

    case unit_dis_5: 
      options.ueq (Options::DISCOUNT,5);
      opts << options << "\n";
      return;

    case unit_dis_10: 
      options.ueq (Options::DISCOUNT,10);
      opts << options << "\n";
      return;

    case unit_dis_50: 
      options.ueq (Options::DISCOUNT,50);
      opts << options << "\n";
      return;

    case unit_ott_1: 
      options.ueq (Options::OTTER,1);
      opts << options << "\n";
      return;

    case unit_ott_3: 
      options.ueq (Options::OTTER,3);
      opts << options << "\n";
      return;

    case HEU001:  
      options.str001 ();
      opts << options << "\n";
      return;

    case HEU002:  
      options.str002 ();
      opts << options << "\n";
      return;

    case HEU003:  
      options.str003 ();
      opts << options << "\n";
      return;

    case HEU004:  
      options.str004 ();
      opts << options << "\n";
      return;

    case HEU005:  
      options.str005 ();
      opts << options << "\n";
      return;

    case HEU006:  
      options.str006 ();
      opts << options << "\n";
      return;

    case HEU007:  
      options.str009 ();
      opts << options << "\n";
      return;

    case HEU008: 
      options.str010 ();
      opts << options << "\n";
      return;

    case HEU009: 
      options.str011 ();
      opts << options << "\n";
      return;

    case HEU010: 
      options.str012 ();
      opts << options << "\n";
      return;

    case HEU011: 
      options.str013 ();
      opts << options << "\n";
      return;

    case HEU012: 
      options.str007 ();
      opts << options << "\n";
      return;

    case HEU013: 
      options.str008 ();
      opts << options << "\n";
      return;

    case HEU014: 
      options.str016 ();
      opts << options << "\n";
      return;

    case HEU015: 
      options.str017 ();
      opts << options << "\n";
      return;

    case HEU016: 
      options.str019 ();
      opts << options << "\n";
      return;

    case HEU017: {
      int largeTime = (timeLimit * 11)/10;
      options.timeLimit (largeTime);
      options.str020 ();
      opts << options << "\n";
      return;
    }

    case HEU018: 
      options.str021 ();
      opts << options << "\n";
      return;

    case HEU019: 
      options.str023 ();
      opts << options << "\n";
      return;

    case HEU020: 
      options.str026 ();
      opts << options << "\n";
      return;

    case HEU022: 
      options.str027 ();
      opts << options << "\n";
      return;

    case HEU023: 
      options.str029 ();
      opts << options << "\n";
      return;

    case HEU021: 
      options.str028 ();
      opts << options << "\n";
      return;

    case HEU024: 
      options.str030 ();
      opts << options << "\n";
      return;

    case HEU025: 
      options.str031 ();
      opts << options << "\n";
      return;

    case HEU026:
      options.str014 ();
      opts << options << "\n";
      return;

    case HEU027:
      options.str015 ();
      opts << options << "\n";
      return;

    case HEU028:
      options.str036 ();
      opts << options << "\n";
      return;

    case HEU029:
      options.str032 ();
      opts << options << "\n";
      return;

    case HEU030:
      options.str033 ();
      opts << options << "\n";
      return;

    case HEU031:
      options.str034 ();
      opts << options << "\n";
      return;

    case HEU032:
      options.str035 ();
      opts << options << "\n";
      return;

    case HEU033:
      options.str037 ();
      opts << options << "\n";
      return;

    case slicing_01: 
      options.timeLimit (slice4); 
      options.lrs (1002,5);
      opts << options << "\n";
      
      options.reset (); 
      options.timeLimit (timeLimit - slice4);
      options.lrs (-4,5);
      options.precedence (Options::KINKY);
      opts << options << "\n";
      return;

    case slicing_02: 
      options.timeLimit (slice2);
      
      options.lrs (1003,5);
      opts << options << "\n";
      
      options.reset (); 
      options.timeLimit (timeLimit - slice2);
      options.lrs (-4,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      return;

    case slicing_03: 
      options.timeLimit (slice5);
      options.lrs (7,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      
      options.timeLimit (timeLimit);  
      options.reset ();
      options.str018 ();
      opts << options << "\n";
      return;

    case slicing_04: {
      int small = timeLimit/20;
      options.timeLimit (small);
      options.ueq (Options::DISCOUNT,10);
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (timeLimit);  
      options.reset ();
      options.ueq (Options::LRS,50);
      opts << options << "\n";
      return;
    }

    case slicing_05: 
      options.timeLimit (2*slice5);
      options.str025 ();
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (timeLimit-3*slice5);
      options.str022 ();
      opts << options << "\n";

      options.reset ();
      options.timeLimit (slice5);
      options.str024 ();
      opts << options << "\n";
      return;

    case slicing_06: 
      options.timeLimit (slice2);
      options.lrs (1006,5);
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (timeLimit-slice2);
      options.lrs (-4,5);
      opts << options << "\n";
      return;

    case slicing_07: 
      options.timeLimit (slice2);
      options.lrs (-4,5);
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (timeLimit-slice2);
      options.lrs (4,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      return;

    case slicing_08: 
      options.timeLimit (slice5);
      options.ueq (Options::DISCOUNT,5);
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (timeLimit-slice5);
      options.ueq (Options::LRS,100);
      opts << options << "\n";
      return;

    case slicing_09: 
      options.timeLimit (slice2);
      options.lrs (4,5);
      options.literalComparison (Options::NORMAL);
      opts << options << "\n";
      
      options.reset ();
      options.timeLimit (timeLimit-slice2);
      options.lrs (-5,5);
      opts << options << "\n";
      return;

    case UNDEFINED:
      ASSERT ( debug_strategy, false );
      return;
  }
} // Strategy::execute
