//
//  file strategy.h (strategies)
//  07/06/2001 Manchester
//


#ifndef __strategy__
#define __strategy__


class Options;
class Prepro;
class Property;
class ostream;


#include "list.h"


class Strategy {
 public:

  enum Pre {
    NONE,
    A, C, D, E, F,
    AD, AF, CD, CF, DE, DF, EF,
  };

  enum Strat {
    UNDEFINED,

    NEQ,
    NNE,
    HEQ,
    PEQ,
    HNE,
    UEQ,
    EPR,

    dis_1,
    dis_2,
    dis_4,
    dis_5,
    dis_n3,
    dis_n4,
    dis_n5,
    dis_1002,
    dis_1003,
    dis_1004,

    lrs_1,
    lrs_1_lcn,
    lrs_1_kinky,
    lrs_2,
    lrs_2_kinky,
    lrs_3,
    lrs_3_kinky,
    lrs_4,
    lrs_4_lcn,
    lrs_4_kinky,
    lrs_5,
    lrs_5_lcn,
    lrs_5_kinky,
    lrs_7_lcn,
    lrs_1002,
    lrs_1003,
    lrs_1004,
    lrs_1005,
    lrs_1006,
    lrs_1007,
    lrs_1008,
    lrs_n2,
    lrs_n2_kinky,
    lrs_n4,
    lrs_n4_kinky,
    lrs_n4_kinky_awr10,
    lrs_n5,
    lrs_n5_kinky,

    ott_1,
    ott_n4,

    unit_dis_5,
    unit_dis_10,
    unit_dis_50,
    unit_lrs_3,
    unit_lrs_5,
    unit_lrs_26,
    unit_ott_1,
    unit_ott_3,

    HEU001,
    HEU002,
    HEU003,
    HEU004,
    HEU005,
    HEU006,
    HEU007,
    HEU008,
    HEU009,
    HEU010,
    HEU011,
    HEU012,
    HEU013,
    HEU014,
    HEU015,
    HEU016,
    HEU017,
    HEU018,
    HEU019,
    HEU020,
    HEU021,
    HEU022,
    HEU023,
    HEU024,
    HEU025,
    HEU026,
    HEU027,
    HEU028,
    HEU029,
    HEU030,
    HEU031,
    HEU032,
    HEU033,

    slicing_01,
    slicing_02,
    slicing_03,
    slicing_04,
    slicing_05,
    slicing_06,
    slicing_07,
    slicing_08,
    slicing_09,
  };

  // constructor
  explicit Strategy (Property&);

  // query/change structure
  //PreList* pre () const { return _pre; }
  //OptList* options () const { return _options; }

  // output
  void execute (Prepro&,ostream& options, ostream& problem, int timeLimit,int memLimit,char* tabFile, ostream& tab);

 private:
  Property& _property;
}; // class Strategy


#endif // __strategy__
